// package: supervisor
// file: info.proto

import * as jspb from "google-protobuf";

export class WorkspaceInfoRequest extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): WorkspaceInfoRequest.AsObject;
  static toObject(includeInstance: boolean, msg: WorkspaceInfoRequest): WorkspaceInfoRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: WorkspaceInfoRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): WorkspaceInfoRequest;
  static deserializeBinaryFromReader(message: WorkspaceInfoRequest, reader: jspb.BinaryReader): WorkspaceInfoRequest;
}

export namespace WorkspaceInfoRequest {
  export type AsObject = {
  }
}

export class WorkspaceInfoResponse extends jspb.Message {
  getWorkspaceId(): string;
  setWorkspaceId(value: string): void;

  getInstanceId(): string;
  setInstanceId(value: string): void;

  getCheckoutLocation(): string;
  setCheckoutLocation(value: string): void;

  hasWorkspaceLocationFile(): boolean;
  clearWorkspaceLocationFile(): void;
  getWorkspaceLocationFile(): string;
  setWorkspaceLocationFile(value: string): void;

  hasWorkspaceLocationFolder(): boolean;
  clearWorkspaceLocationFolder(): void;
  getWorkspaceLocationFolder(): string;
  setWorkspaceLocationFolder(value: string): void;

  getUserHome(): string;
  setUserHome(value: string): void;

  hasGitpodApi(): boolean;
  clearGitpodApi(): void;
  getGitpodApi(): WorkspaceInfoResponse.GitpodAPI | undefined;
  setGitpodApi(value?: WorkspaceInfoResponse.GitpodAPI): void;

  getGitpodHost(): string;
  setGitpodHost(value: string): void;

  getWorkspaceContextUrl(): string;
  setWorkspaceContextUrl(value: string): void;

  hasRepository(): boolean;
  clearRepository(): void;
  getRepository(): WorkspaceInfoResponse.Repository | undefined;
  setRepository(value?: WorkspaceInfoResponse.Repository): void;

  getWorkspaceClusterHost(): string;
  setWorkspaceClusterHost(value: string): void;

  getWorkspaceUrl(): string;
  setWorkspaceUrl(value: string): void;

  getIdeAlias(): string;
  setIdeAlias(value: string): void;

  getIdePort(): number;
  setIdePort(value: number): void;

  hasWorkspaceClass(): boolean;
  clearWorkspaceClass(): void;
  getWorkspaceClass(): WorkspaceInfoResponse.WorkspaceClass | undefined;
  setWorkspaceClass(value?: WorkspaceInfoResponse.WorkspaceClass): void;

  getOwnerId(): string;
  setOwnerId(value: string): void;

  getDebugWorkspaceType(): DebugWorkspaceTypeMap[keyof DebugWorkspaceTypeMap];
  setDebugWorkspaceType(value: DebugWorkspaceTypeMap[keyof DebugWorkspaceTypeMap]): void;

  getConfigcatEnabled(): boolean;
  setConfigcatEnabled(value: boolean): void;

  getWorkspaceLocationCase(): WorkspaceInfoResponse.WorkspaceLocationCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): WorkspaceInfoResponse.AsObject;
  static toObject(includeInstance: boolean, msg: WorkspaceInfoResponse): WorkspaceInfoResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: WorkspaceInfoResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): WorkspaceInfoResponse;
  static deserializeBinaryFromReader(message: WorkspaceInfoResponse, reader: jspb.BinaryReader): WorkspaceInfoResponse;
}

export namespace WorkspaceInfoResponse {
  export type AsObject = {
    workspaceId: string,
    instanceId: string,
    checkoutLocation: string,
    workspaceLocationFile: string,
    workspaceLocationFolder: string,
    userHome: string,
    gitpodApi?: WorkspaceInfoResponse.GitpodAPI.AsObject,
    gitpodHost: string,
    workspaceContextUrl: string,
    repository?: WorkspaceInfoResponse.Repository.AsObject,
    workspaceClusterHost: string,
    workspaceUrl: string,
    ideAlias: string,
    idePort: number,
    workspaceClass?: WorkspaceInfoResponse.WorkspaceClass.AsObject,
    ownerId: string,
    debugWorkspaceType: DebugWorkspaceTypeMap[keyof DebugWorkspaceTypeMap],
    configcatEnabled: boolean,
  }

  export class GitpodAPI extends jspb.Message {
    getEndpoint(): string;
    setEndpoint(value: string): void;

    getHost(): string;
    setHost(value: string): void;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): GitpodAPI.AsObject;
    static toObject(includeInstance: boolean, msg: GitpodAPI): GitpodAPI.AsObject;
    static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
    static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
    static serializeBinaryToWriter(message: GitpodAPI, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): GitpodAPI;
    static deserializeBinaryFromReader(message: GitpodAPI, reader: jspb.BinaryReader): GitpodAPI;
  }

  export namespace GitpodAPI {
    export type AsObject = {
      endpoint: string,
      host: string,
    }
  }

  export class Repository extends jspb.Message {
    getOwner(): string;
    setOwner(value: string): void;

    getName(): string;
    setName(value: string): void;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): Repository.AsObject;
    static toObject(includeInstance: boolean, msg: Repository): Repository.AsObject;
    static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
    static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
    static serializeBinaryToWriter(message: Repository, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): Repository;
    static deserializeBinaryFromReader(message: Repository, reader: jspb.BinaryReader): Repository;
  }

  export namespace Repository {
    export type AsObject = {
      owner: string,
      name: string,
    }
  }

  export class WorkspaceClass extends jspb.Message {
    getId(): string;
    setId(value: string): void;

    getDisplayName(): string;
    setDisplayName(value: string): void;

    getDescription(): string;
    setDescription(value: string): void;

    serializeBinary(): Uint8Array;
    toObject(includeInstance?: boolean): WorkspaceClass.AsObject;
    static toObject(includeInstance: boolean, msg: WorkspaceClass): WorkspaceClass.AsObject;
    static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
    static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
    static serializeBinaryToWriter(message: WorkspaceClass, writer: jspb.BinaryWriter): void;
    static deserializeBinary(bytes: Uint8Array): WorkspaceClass;
    static deserializeBinaryFromReader(message: WorkspaceClass, reader: jspb.BinaryReader): WorkspaceClass;
  }

  export namespace WorkspaceClass {
    export type AsObject = {
      id: string,
      displayName: string,
      description: string,
    }
  }

  export enum WorkspaceLocationCase {
    WORKSPACE_LOCATION_NOT_SET = 0,
    WORKSPACE_LOCATION_FILE = 4,
    WORKSPACE_LOCATION_FOLDER = 5,
  }
}

export interface DebugWorkspaceTypeMap {
  NODEBUG: 0;
  REGULAR: 1;
  PREBUILD: 2;
}

export const DebugWorkspaceType: DebugWorkspaceTypeMap;

