// package: supervisor
// file: notification.proto

import * as notification_pb from "./notification_pb";
import {grpc} from "@improbable-eng/grpc-web";

type NotificationServiceNotify = {
  readonly methodName: string;
  readonly service: typeof NotificationService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof notification_pb.NotifyRequest;
  readonly responseType: typeof notification_pb.NotifyResponse;
};

type NotificationServiceSubscribe = {
  readonly methodName: string;
  readonly service: typeof NotificationService;
  readonly requestStream: false;
  readonly responseStream: true;
  readonly requestType: typeof notification_pb.SubscribeRequest;
  readonly responseType: typeof notification_pb.SubscribeResponse;
};

type NotificationServiceRespond = {
  readonly methodName: string;
  readonly service: typeof NotificationService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof notification_pb.RespondRequest;
  readonly responseType: typeof notification_pb.RespondResponse;
};

type NotificationServiceSubscribeActive = {
  readonly methodName: string;
  readonly service: typeof NotificationService;
  readonly requestStream: false;
  readonly responseStream: true;
  readonly requestType: typeof notification_pb.SubscribeActiveRequest;
  readonly responseType: typeof notification_pb.SubscribeActiveResponse;
};

type NotificationServiceNotifyActive = {
  readonly methodName: string;
  readonly service: typeof NotificationService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof notification_pb.NotifyActiveRequest;
  readonly responseType: typeof notification_pb.NotifyActiveResponse;
};

type NotificationServiceNotifyActiveRespond = {
  readonly methodName: string;
  readonly service: typeof NotificationService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof notification_pb.NotifyActiveRespondRequest;
  readonly responseType: typeof notification_pb.NotifyActiveRespondResponse;
};

export class NotificationService {
  static readonly serviceName: string;
  static readonly Notify: NotificationServiceNotify;
  static readonly Subscribe: NotificationServiceSubscribe;
  static readonly Respond: NotificationServiceRespond;
  static readonly SubscribeActive: NotificationServiceSubscribeActive;
  static readonly NotifyActive: NotificationServiceNotifyActive;
  static readonly NotifyActiveRespond: NotificationServiceNotifyActiveRespond;
}

export type ServiceError = { message: string, code: number; metadata: grpc.Metadata }
export type Status = { details: string, code: number; metadata: grpc.Metadata }

interface UnaryResponse {
  cancel(): void;
}
interface ResponseStream<T> {
  cancel(): void;
  on(type: 'data', handler: (message: T) => void): ResponseStream<T>;
  on(type: 'end', handler: (status?: Status) => void): ResponseStream<T>;
  on(type: 'status', handler: (status: Status) => void): ResponseStream<T>;
}
interface RequestStream<T> {
  write(message: T): RequestStream<T>;
  end(): void;
  cancel(): void;
  on(type: 'end', handler: (status?: Status) => void): RequestStream<T>;
  on(type: 'status', handler: (status: Status) => void): RequestStream<T>;
}
interface BidirectionalStream<ReqT, ResT> {
  write(message: ReqT): BidirectionalStream<ReqT, ResT>;
  end(): void;
  cancel(): void;
  on(type: 'data', handler: (message: ResT) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'end', handler: (status?: Status) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'status', handler: (status: Status) => void): BidirectionalStream<ReqT, ResT>;
}

export class NotificationServiceClient {
  readonly serviceHost: string;

  constructor(serviceHost: string, options?: grpc.RpcOptions);
  notify(
    requestMessage: notification_pb.NotifyRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: notification_pb.NotifyResponse|null) => void
  ): UnaryResponse;
  notify(
    requestMessage: notification_pb.NotifyRequest,
    callback: (error: ServiceError|null, responseMessage: notification_pb.NotifyResponse|null) => void
  ): UnaryResponse;
  subscribe(requestMessage: notification_pb.SubscribeRequest, metadata?: grpc.Metadata): ResponseStream<notification_pb.SubscribeResponse>;
  respond(
    requestMessage: notification_pb.RespondRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: notification_pb.RespondResponse|null) => void
  ): UnaryResponse;
  respond(
    requestMessage: notification_pb.RespondRequest,
    callback: (error: ServiceError|null, responseMessage: notification_pb.RespondResponse|null) => void
  ): UnaryResponse;
  subscribeActive(requestMessage: notification_pb.SubscribeActiveRequest, metadata?: grpc.Metadata): ResponseStream<notification_pb.SubscribeActiveResponse>;
  notifyActive(
    requestMessage: notification_pb.NotifyActiveRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: notification_pb.NotifyActiveResponse|null) => void
  ): UnaryResponse;
  notifyActive(
    requestMessage: notification_pb.NotifyActiveRequest,
    callback: (error: ServiceError|null, responseMessage: notification_pb.NotifyActiveResponse|null) => void
  ): UnaryResponse;
  notifyActiveRespond(
    requestMessage: notification_pb.NotifyActiveRespondRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: notification_pb.NotifyActiveRespondResponse|null) => void
  ): UnaryResponse;
  notifyActiveRespond(
    requestMessage: notification_pb.NotifyActiveRespondRequest,
    callback: (error: ServiceError|null, responseMessage: notification_pb.NotifyActiveRespondResponse|null) => void
  ): UnaryResponse;
}

