// package: supervisor
// file: status.proto

import * as status_pb from "./status_pb";
import {grpc} from "@improbable-eng/grpc-web";

type StatusServiceSupervisorStatus = {
  readonly methodName: string;
  readonly service: typeof StatusService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof status_pb.SupervisorStatusRequest;
  readonly responseType: typeof status_pb.SupervisorStatusResponse;
};

type StatusServiceIDEStatus = {
  readonly methodName: string;
  readonly service: typeof StatusService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof status_pb.IDEStatusRequest;
  readonly responseType: typeof status_pb.IDEStatusResponse;
};

type StatusServiceContentStatus = {
  readonly methodName: string;
  readonly service: typeof StatusService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof status_pb.ContentStatusRequest;
  readonly responseType: typeof status_pb.ContentStatusResponse;
};

type StatusServiceBackupStatus = {
  readonly methodName: string;
  readonly service: typeof StatusService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof status_pb.BackupStatusRequest;
  readonly responseType: typeof status_pb.BackupStatusResponse;
};

type StatusServicePortsStatus = {
  readonly methodName: string;
  readonly service: typeof StatusService;
  readonly requestStream: false;
  readonly responseStream: true;
  readonly requestType: typeof status_pb.PortsStatusRequest;
  readonly responseType: typeof status_pb.PortsStatusResponse;
};

type StatusServiceTasksStatus = {
  readonly methodName: string;
  readonly service: typeof StatusService;
  readonly requestStream: false;
  readonly responseStream: true;
  readonly requestType: typeof status_pb.TasksStatusRequest;
  readonly responseType: typeof status_pb.TasksStatusResponse;
};

type StatusServiceResourcesStatus = {
  readonly methodName: string;
  readonly service: typeof StatusService;
  readonly requestStream: false;
  readonly responseStream: false;
  readonly requestType: typeof status_pb.ResourcesStatuRequest;
  readonly responseType: typeof status_pb.ResourcesStatusResponse;
};

export class StatusService {
  static readonly serviceName: string;
  static readonly SupervisorStatus: StatusServiceSupervisorStatus;
  static readonly IDEStatus: StatusServiceIDEStatus;
  static readonly ContentStatus: StatusServiceContentStatus;
  static readonly BackupStatus: StatusServiceBackupStatus;
  static readonly PortsStatus: StatusServicePortsStatus;
  static readonly TasksStatus: StatusServiceTasksStatus;
  static readonly ResourcesStatus: StatusServiceResourcesStatus;
}

export type ServiceError = { message: string, code: number; metadata: grpc.Metadata }
export type Status = { details: string, code: number; metadata: grpc.Metadata }

interface UnaryResponse {
  cancel(): void;
}
interface ResponseStream<T> {
  cancel(): void;
  on(type: 'data', handler: (message: T) => void): ResponseStream<T>;
  on(type: 'end', handler: (status?: Status) => void): ResponseStream<T>;
  on(type: 'status', handler: (status: Status) => void): ResponseStream<T>;
}
interface RequestStream<T> {
  write(message: T): RequestStream<T>;
  end(): void;
  cancel(): void;
  on(type: 'end', handler: (status?: Status) => void): RequestStream<T>;
  on(type: 'status', handler: (status: Status) => void): RequestStream<T>;
}
interface BidirectionalStream<ReqT, ResT> {
  write(message: ReqT): BidirectionalStream<ReqT, ResT>;
  end(): void;
  cancel(): void;
  on(type: 'data', handler: (message: ResT) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'end', handler: (status?: Status) => void): BidirectionalStream<ReqT, ResT>;
  on(type: 'status', handler: (status: Status) => void): BidirectionalStream<ReqT, ResT>;
}

export class StatusServiceClient {
  readonly serviceHost: string;

  constructor(serviceHost: string, options?: grpc.RpcOptions);
  supervisorStatus(
    requestMessage: status_pb.SupervisorStatusRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: status_pb.SupervisorStatusResponse|null) => void
  ): UnaryResponse;
  supervisorStatus(
    requestMessage: status_pb.SupervisorStatusRequest,
    callback: (error: ServiceError|null, responseMessage: status_pb.SupervisorStatusResponse|null) => void
  ): UnaryResponse;
  iDEStatus(
    requestMessage: status_pb.IDEStatusRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: status_pb.IDEStatusResponse|null) => void
  ): UnaryResponse;
  iDEStatus(
    requestMessage: status_pb.IDEStatusRequest,
    callback: (error: ServiceError|null, responseMessage: status_pb.IDEStatusResponse|null) => void
  ): UnaryResponse;
  contentStatus(
    requestMessage: status_pb.ContentStatusRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: status_pb.ContentStatusResponse|null) => void
  ): UnaryResponse;
  contentStatus(
    requestMessage: status_pb.ContentStatusRequest,
    callback: (error: ServiceError|null, responseMessage: status_pb.ContentStatusResponse|null) => void
  ): UnaryResponse;
  backupStatus(
    requestMessage: status_pb.BackupStatusRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: status_pb.BackupStatusResponse|null) => void
  ): UnaryResponse;
  backupStatus(
    requestMessage: status_pb.BackupStatusRequest,
    callback: (error: ServiceError|null, responseMessage: status_pb.BackupStatusResponse|null) => void
  ): UnaryResponse;
  portsStatus(requestMessage: status_pb.PortsStatusRequest, metadata?: grpc.Metadata): ResponseStream<status_pb.PortsStatusResponse>;
  tasksStatus(requestMessage: status_pb.TasksStatusRequest, metadata?: grpc.Metadata): ResponseStream<status_pb.TasksStatusResponse>;
  resourcesStatus(
    requestMessage: status_pb.ResourcesStatuRequest,
    metadata: grpc.Metadata,
    callback: (error: ServiceError|null, responseMessage: status_pb.ResourcesStatusResponse|null) => void
  ): UnaryResponse;
  resourcesStatus(
    requestMessage: status_pb.ResourcesStatuRequest,
    callback: (error: ServiceError|null, responseMessage: status_pb.ResourcesStatusResponse|null) => void
  ): UnaryResponse;
}

