// package: supervisor
// file: terminal.proto

import * as jspb from "google-protobuf";

export class TerminalSize extends jspb.Message {
  getRows(): number;
  setRows(value: number): void;

  getCols(): number;
  setCols(value: number): void;

  getWidthpx(): number;
  setWidthpx(value: number): void;

  getHeightpx(): number;
  setHeightpx(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TerminalSize.AsObject;
  static toObject(includeInstance: boolean, msg: TerminalSize): TerminalSize.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TerminalSize, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TerminalSize;
  static deserializeBinaryFromReader(message: TerminalSize, reader: jspb.BinaryReader): TerminalSize;
}

export namespace TerminalSize {
  export type AsObject = {
    rows: number,
    cols: number,
    widthpx: number,
    heightpx: number,
  }
}

export class OpenTerminalRequest extends jspb.Message {
  getWorkdir(): string;
  setWorkdir(value: string): void;

  getEnvMap(): jspb.Map<string, string>;
  clearEnvMap(): void;
  getAnnotationsMap(): jspb.Map<string, string>;
  clearAnnotationsMap(): void;
  getShell(): string;
  setShell(value: string): void;

  clearShellArgsList(): void;
  getShellArgsList(): Array<string>;
  setShellArgsList(value: Array<string>): void;
  addShellArgs(value: string, index?: number): string;

  hasSize(): boolean;
  clearSize(): void;
  getSize(): TerminalSize | undefined;
  setSize(value?: TerminalSize): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): OpenTerminalRequest.AsObject;
  static toObject(includeInstance: boolean, msg: OpenTerminalRequest): OpenTerminalRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: OpenTerminalRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): OpenTerminalRequest;
  static deserializeBinaryFromReader(message: OpenTerminalRequest, reader: jspb.BinaryReader): OpenTerminalRequest;
}

export namespace OpenTerminalRequest {
  export type AsObject = {
    workdir: string,
    envMap: Array<[string, string]>,
    annotationsMap: Array<[string, string]>,
    shell: string,
    shellArgsList: Array<string>,
    size?: TerminalSize.AsObject,
  }
}

export class OpenTerminalResponse extends jspb.Message {
  hasTerminal(): boolean;
  clearTerminal(): void;
  getTerminal(): Terminal | undefined;
  setTerminal(value?: Terminal): void;

  getStarterToken(): string;
  setStarterToken(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): OpenTerminalResponse.AsObject;
  static toObject(includeInstance: boolean, msg: OpenTerminalResponse): OpenTerminalResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: OpenTerminalResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): OpenTerminalResponse;
  static deserializeBinaryFromReader(message: OpenTerminalResponse, reader: jspb.BinaryReader): OpenTerminalResponse;
}

export namespace OpenTerminalResponse {
  export type AsObject = {
    terminal?: Terminal.AsObject,
    starterToken: string,
  }
}

export class ShutdownTerminalRequest extends jspb.Message {
  getAlias(): string;
  setAlias(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ShutdownTerminalRequest.AsObject;
  static toObject(includeInstance: boolean, msg: ShutdownTerminalRequest): ShutdownTerminalRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ShutdownTerminalRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ShutdownTerminalRequest;
  static deserializeBinaryFromReader(message: ShutdownTerminalRequest, reader: jspb.BinaryReader): ShutdownTerminalRequest;
}

export namespace ShutdownTerminalRequest {
  export type AsObject = {
    alias: string,
  }
}

export class ShutdownTerminalResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ShutdownTerminalResponse.AsObject;
  static toObject(includeInstance: boolean, msg: ShutdownTerminalResponse): ShutdownTerminalResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ShutdownTerminalResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ShutdownTerminalResponse;
  static deserializeBinaryFromReader(message: ShutdownTerminalResponse, reader: jspb.BinaryReader): ShutdownTerminalResponse;
}

export namespace ShutdownTerminalResponse {
  export type AsObject = {
  }
}

export class Terminal extends jspb.Message {
  getAlias(): string;
  setAlias(value: string): void;

  clearCommandList(): void;
  getCommandList(): Array<string>;
  setCommandList(value: Array<string>): void;
  addCommand(value: string, index?: number): string;

  getTitle(): string;
  setTitle(value: string): void;

  getPid(): number;
  setPid(value: number): void;

  getInitialWorkdir(): string;
  setInitialWorkdir(value: string): void;

  getCurrentWorkdir(): string;
  setCurrentWorkdir(value: string): void;

  getAnnotationsMap(): jspb.Map<string, string>;
  clearAnnotationsMap(): void;
  getTitleSource(): TerminalTitleSourceMap[keyof TerminalTitleSourceMap];
  setTitleSource(value: TerminalTitleSourceMap[keyof TerminalTitleSourceMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Terminal.AsObject;
  static toObject(includeInstance: boolean, msg: Terminal): Terminal.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Terminal, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Terminal;
  static deserializeBinaryFromReader(message: Terminal, reader: jspb.BinaryReader): Terminal;
}

export namespace Terminal {
  export type AsObject = {
    alias: string,
    commandList: Array<string>,
    title: string,
    pid: number,
    initialWorkdir: string,
    currentWorkdir: string,
    annotationsMap: Array<[string, string]>,
    titleSource: TerminalTitleSourceMap[keyof TerminalTitleSourceMap],
  }
}

export class GetTerminalRequest extends jspb.Message {
  getAlias(): string;
  setAlias(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): GetTerminalRequest.AsObject;
  static toObject(includeInstance: boolean, msg: GetTerminalRequest): GetTerminalRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: GetTerminalRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): GetTerminalRequest;
  static deserializeBinaryFromReader(message: GetTerminalRequest, reader: jspb.BinaryReader): GetTerminalRequest;
}

export namespace GetTerminalRequest {
  export type AsObject = {
    alias: string,
  }
}

export class ListTerminalsRequest extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ListTerminalsRequest.AsObject;
  static toObject(includeInstance: boolean, msg: ListTerminalsRequest): ListTerminalsRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ListTerminalsRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ListTerminalsRequest;
  static deserializeBinaryFromReader(message: ListTerminalsRequest, reader: jspb.BinaryReader): ListTerminalsRequest;
}

export namespace ListTerminalsRequest {
  export type AsObject = {
  }
}

export class ListTerminalsResponse extends jspb.Message {
  clearTerminalsList(): void;
  getTerminalsList(): Array<Terminal>;
  setTerminalsList(value: Array<Terminal>): void;
  addTerminals(value?: Terminal, index?: number): Terminal;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ListTerminalsResponse.AsObject;
  static toObject(includeInstance: boolean, msg: ListTerminalsResponse): ListTerminalsResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ListTerminalsResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ListTerminalsResponse;
  static deserializeBinaryFromReader(message: ListTerminalsResponse, reader: jspb.BinaryReader): ListTerminalsResponse;
}

export namespace ListTerminalsResponse {
  export type AsObject = {
    terminalsList: Array<Terminal.AsObject>,
  }
}

export class ListenTerminalRequest extends jspb.Message {
  getAlias(): string;
  setAlias(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ListenTerminalRequest.AsObject;
  static toObject(includeInstance: boolean, msg: ListenTerminalRequest): ListenTerminalRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ListenTerminalRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ListenTerminalRequest;
  static deserializeBinaryFromReader(message: ListenTerminalRequest, reader: jspb.BinaryReader): ListenTerminalRequest;
}

export namespace ListenTerminalRequest {
  export type AsObject = {
    alias: string,
  }
}

export class ListenTerminalResponse extends jspb.Message {
  hasData(): boolean;
  clearData(): void;
  getData(): Uint8Array | string;
  getData_asU8(): Uint8Array;
  getData_asB64(): string;
  setData(value: Uint8Array | string): void;

  hasExitCode(): boolean;
  clearExitCode(): void;
  getExitCode(): number;
  setExitCode(value: number): void;

  hasTitle(): boolean;
  clearTitle(): void;
  getTitle(): string;
  setTitle(value: string): void;

  getTitleSource(): TerminalTitleSourceMap[keyof TerminalTitleSourceMap];
  setTitleSource(value: TerminalTitleSourceMap[keyof TerminalTitleSourceMap]): void;

  getOutputCase(): ListenTerminalResponse.OutputCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ListenTerminalResponse.AsObject;
  static toObject(includeInstance: boolean, msg: ListenTerminalResponse): ListenTerminalResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ListenTerminalResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ListenTerminalResponse;
  static deserializeBinaryFromReader(message: ListenTerminalResponse, reader: jspb.BinaryReader): ListenTerminalResponse;
}

export namespace ListenTerminalResponse {
  export type AsObject = {
    data: Uint8Array | string,
    exitCode: number,
    title: string,
    titleSource: TerminalTitleSourceMap[keyof TerminalTitleSourceMap],
  }

  export enum OutputCase {
    OUTPUT_NOT_SET = 0,
    DATA = 1,
    EXIT_CODE = 2,
    TITLE = 3,
  }
}

export class WriteTerminalRequest extends jspb.Message {
  getAlias(): string;
  setAlias(value: string): void;

  getStdin(): Uint8Array | string;
  getStdin_asU8(): Uint8Array;
  getStdin_asB64(): string;
  setStdin(value: Uint8Array | string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): WriteTerminalRequest.AsObject;
  static toObject(includeInstance: boolean, msg: WriteTerminalRequest): WriteTerminalRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: WriteTerminalRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): WriteTerminalRequest;
  static deserializeBinaryFromReader(message: WriteTerminalRequest, reader: jspb.BinaryReader): WriteTerminalRequest;
}

export namespace WriteTerminalRequest {
  export type AsObject = {
    alias: string,
    stdin: Uint8Array | string,
  }
}

export class WriteTerminalResponse extends jspb.Message {
  getBytesWritten(): number;
  setBytesWritten(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): WriteTerminalResponse.AsObject;
  static toObject(includeInstance: boolean, msg: WriteTerminalResponse): WriteTerminalResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: WriteTerminalResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): WriteTerminalResponse;
  static deserializeBinaryFromReader(message: WriteTerminalResponse, reader: jspb.BinaryReader): WriteTerminalResponse;
}

export namespace WriteTerminalResponse {
  export type AsObject = {
    bytesWritten: number,
  }
}

export class SetTerminalSizeRequest extends jspb.Message {
  getAlias(): string;
  setAlias(value: string): void;

  hasToken(): boolean;
  clearToken(): void;
  getToken(): string;
  setToken(value: string): void;

  hasForce(): boolean;
  clearForce(): void;
  getForce(): boolean;
  setForce(value: boolean): void;

  hasSize(): boolean;
  clearSize(): void;
  getSize(): TerminalSize | undefined;
  setSize(value?: TerminalSize): void;

  getPriorityCase(): SetTerminalSizeRequest.PriorityCase;
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SetTerminalSizeRequest.AsObject;
  static toObject(includeInstance: boolean, msg: SetTerminalSizeRequest): SetTerminalSizeRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SetTerminalSizeRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SetTerminalSizeRequest;
  static deserializeBinaryFromReader(message: SetTerminalSizeRequest, reader: jspb.BinaryReader): SetTerminalSizeRequest;
}

export namespace SetTerminalSizeRequest {
  export type AsObject = {
    alias: string,
    token: string,
    force: boolean,
    size?: TerminalSize.AsObject,
  }

  export enum PriorityCase {
    PRIORITY_NOT_SET = 0,
    TOKEN = 2,
    FORCE = 3,
  }
}

export class SetTerminalSizeResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SetTerminalSizeResponse.AsObject;
  static toObject(includeInstance: boolean, msg: SetTerminalSizeResponse): SetTerminalSizeResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SetTerminalSizeResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SetTerminalSizeResponse;
  static deserializeBinaryFromReader(message: SetTerminalSizeResponse, reader: jspb.BinaryReader): SetTerminalSizeResponse;
}

export namespace SetTerminalSizeResponse {
  export type AsObject = {
  }
}

export class SetTerminalTitleRequest extends jspb.Message {
  getAlias(): string;
  setAlias(value: string): void;

  getTitle(): string;
  setTitle(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SetTerminalTitleRequest.AsObject;
  static toObject(includeInstance: boolean, msg: SetTerminalTitleRequest): SetTerminalTitleRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SetTerminalTitleRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SetTerminalTitleRequest;
  static deserializeBinaryFromReader(message: SetTerminalTitleRequest, reader: jspb.BinaryReader): SetTerminalTitleRequest;
}

export namespace SetTerminalTitleRequest {
  export type AsObject = {
    alias: string,
    title: string,
  }
}

export class SetTerminalTitleResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SetTerminalTitleResponse.AsObject;
  static toObject(includeInstance: boolean, msg: SetTerminalTitleResponse): SetTerminalTitleResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SetTerminalTitleResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SetTerminalTitleResponse;
  static deserializeBinaryFromReader(message: SetTerminalTitleResponse, reader: jspb.BinaryReader): SetTerminalTitleResponse;
}

export namespace SetTerminalTitleResponse {
  export type AsObject = {
  }
}

export class UpdateTerminalAnnotationsRequest extends jspb.Message {
  getAlias(): string;
  setAlias(value: string): void;

  getChangedMap(): jspb.Map<string, string>;
  clearChangedMap(): void;
  clearDeletedList(): void;
  getDeletedList(): Array<string>;
  setDeletedList(value: Array<string>): void;
  addDeleted(value: string, index?: number): string;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateTerminalAnnotationsRequest.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateTerminalAnnotationsRequest): UpdateTerminalAnnotationsRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UpdateTerminalAnnotationsRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateTerminalAnnotationsRequest;
  static deserializeBinaryFromReader(message: UpdateTerminalAnnotationsRequest, reader: jspb.BinaryReader): UpdateTerminalAnnotationsRequest;
}

export namespace UpdateTerminalAnnotationsRequest {
  export type AsObject = {
    alias: string,
    changedMap: Array<[string, string]>,
    deletedList: Array<string>,
  }
}

export class UpdateTerminalAnnotationsResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateTerminalAnnotationsResponse.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateTerminalAnnotationsResponse): UpdateTerminalAnnotationsResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UpdateTerminalAnnotationsResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateTerminalAnnotationsResponse;
  static deserializeBinaryFromReader(message: UpdateTerminalAnnotationsResponse, reader: jspb.BinaryReader): UpdateTerminalAnnotationsResponse;
}

export namespace UpdateTerminalAnnotationsResponse {
  export type AsObject = {
  }
}

export interface TerminalTitleSourceMap {
  PROCESS: 0;
  API: 1;
}

export const TerminalTitleSource: TerminalTitleSourceMap;

